diff -urN Original_4.4.4_r1/frameworks/base/Android.mk AndroidSource/frameworks/base/Android.mk
--- Original_4.4.4_r1/frameworks/base/Android.mk	2016-01-29 15:12:27.311488000 +0900
+++ AndroidSource/frameworks/base/Android.mk	2016-03-04 14:12:40.000000000 +0900
@@ -52,6 +52,9 @@
 ## across process boundaries.
 ##
 ## READ ME: ########################################################
+
+	## ADDED END BY JH at 180th
+
 LOCAL_SRC_FILES += \
 	core/java/android/accessibilityservice/IAccessibilityServiceConnection.aidl \
 	core/java/android/accessibilityservice/IAccessibilityServiceClient.aidl \
@@ -161,6 +164,7 @@
 	core/java/android/os/IUpdateLock.aidl \
 	core/java/android/os/IUserManager.aidl \
 	core/java/android/os/IVibratorService.aidl \
+	core/java/android/service/distribute/IDistributedComputingService.aidl \
 	core/java/android/service/notification/INotificationListener.aidl \
 	core/java/android/print/ILayoutResultCallback.aidl \
 	core/java/android/print/IPrinterDiscoveryObserver.aidl \
@@ -176,6 +180,9 @@
 	core/java/android/printservice/IPrintServiceClient.aidl \
 	core/java/android/service/dreams/IDreamManager.aidl \
 	core/java/android/service/dreams/IDreamService.aidl \
+	core/java/android/service/collaboroid/IGeneralMessageListener.aidl \
+	core/java/android/service/devicemanager/IDeviceManager.aidl \
+	core/java/android/service/remote/IRemoteService.aidl \
 	core/java/android/service/wallpaper/IWallpaperConnection.aidl \
 	core/java/android/service/wallpaper/IWallpaperEngine.aidl \
 	core/java/android/service/wallpaper/IWallpaperService.aidl \
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/app/ContextImpl.java AndroidSource/frameworks/base/core/java/android/app/ContextImpl.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/app/ContextImpl.java	2016-01-29 15:12:27.379488000 +0900
+++ AndroidSource/frameworks/base/core/java/android/app/ContextImpl.java	2016-03-02 19:22:11.000000000 +0900
@@ -17,6 +17,7 @@
 package android.app;
 
 import android.os.Build;
+
 import com.android.internal.policy.PolicyManager;
 import com.android.internal.util.Preconditions;
 
@@ -94,6 +95,9 @@
 import android.os.UserManager;
 import android.os.storage.IMountService;
 import android.os.storage.StorageManager;
+import android.service.remote.RemoteServiceManager;
+import android.service.collaboroid.CollaboRoidManager;
+import android.service.devicemanager.DeviceManager;
 import android.print.IPrintManager;
 import android.print.PrintManager;
 import android.telephony.TelephonyManager;
@@ -595,6 +599,26 @@
             public Object createService(ContextImpl ctx) {
                 return new ConsumerIrManager(ctx);
             }});
+        
+        // ADDED FOR COLLABOROID
+        registerService(COLLABOROID, new ServiceFetcher(){
+            public Object createService(ContextImpl ctx){
+                return new CollaboRoidManager(ctx);
+            }
+        });
+        
+        registerService(REMOTE_SERVICE, new ServiceFetcher(){
+            public Object createService(ContextImpl ctx){
+                return new RemoteServiceManager(ctx);
+            }
+        });
+        
+        registerService(DEVICE_MANAGEMENT_SERVICE, new ServiceFetcher(){
+            public Object createService(ContextImpl ctx){
+                return new DeviceManager(ctx);
+            }
+        });
+        // ADDED FOR COLLABOROID
     }
 
     static ContextImpl getImpl(Context context) {
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/content/Context.java AndroidSource/frameworks/base/core/java/android/content/Context.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/content/Context.java	2016-01-29 15:12:27.395488000 +0900
+++ AndroidSource/frameworks/base/core/java/android/content/Context.java	2016-03-02 19:26:16.000000000 +0900
@@ -2933,4 +2933,11 @@
     public boolean isRestricted() {
         return false;
     }
+
+	// ADDED FOR COLLABOROID
+    public static final String COLLABOROID = "collaboroid";
+    public static final String REMOTE_SERVICE = "remote";
+    public static final String DEVICE_MANAGEMENT_SERVICE = "devicemanagement";
+    public static final String DISTRIBUTED_COMPUTING_SERVICE = "distribute";
+    // ADDED FOR COLLABOROID
 }
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/hardware/SensorEvent.java AndroidSource/frameworks/base/core/java/android/hardware/SensorEvent.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/hardware/SensorEvent.java	2016-01-29 15:12:27.411488000 +0900
+++ AndroidSource/frameworks/base/core/java/android/hardware/SensorEvent.java	2015-10-19 13:54:46.000000000 +0900
@@ -501,7 +501,22 @@
      */
     public long timestamp;
 
+    /**
+     * ADDED BY JH
+     * The source where sensor events comes
+     */
+    public int sourceDevice;
+    
     SensorEvent(int valueSize) {
         values = new float[valueSize];
     }
+    
+    /*public SensorEvent(float[] v, int acc, long ts, int sd)
+    {
+    	values = v;
+    	sensor = new Sensor("RemoteSensor", Sensor.TYPE_REMOTE_SENSOR, Sensor.TYPE_REMOTE_SENSOR);
+    	accuracy = acc;
+    	timestamp = ts;
+    	sourceDevice = sd;
+    }*/
 }
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/hardware/Sensor.java AndroidSource/frameworks/base/core/java/android/hardware/Sensor.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/hardware/Sensor.java	2016-01-29 15:12:27.411488000 +0900
+++ AndroidSource/frameworks/base/core/java/android/hardware/Sensor.java	2015-09-30 13:32:06.000000000 +0900
@@ -222,6 +222,12 @@
     public static final int TYPE_GEOMAGNETIC_ROTATION_VECTOR = 20;
 
     /**
+     * ADDED BY JH
+     * 
+    */
+    public static final int TYPE_REMOTE_SENSOR = 21;
+    
+    /**
      * A constant describing all sensor types.
      */
     public static final int TYPE_ALL = -1;
@@ -324,6 +330,14 @@
 
     Sensor() {
     }
+    
+    // ADDED BY JH
+    Sensor(String name, int handle, int type)
+    {
+    	mName = name;
+    	mHandle = handle;
+    	mType = type;
+    }
 
     /**
      * @return name string of the sensor.
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/hardware/SystemSensorManager.java AndroidSource/frameworks/base/core/java/android/hardware/SystemSensorManager.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/hardware/SystemSensorManager.java	2016-01-29 15:12:27.411488000 +0900
+++ AndroidSource/frameworks/base/core/java/android/hardware/SystemSensorManager.java	2016-09-23 16:52:20.421092185 +0900
@@ -16,20 +16,23 @@
 
 package android.hardware;
 
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
 import android.content.Context;
 import android.os.Handler;
 import android.os.Looper;
 import android.os.MessageQueue;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.service.remote.IRemoteService;
 import android.util.Log;
 import android.util.SparseArray;
 import android.util.SparseBooleanArray;
 import android.util.SparseIntArray;
 import dalvik.system.CloseGuard;
 
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-
 /**
  * Sensor manager implementation that communicates with the built-in
  * system sensors.
@@ -53,12 +56,21 @@
 
     // Looper associated with the context in which this instance was created.
     private final Looper mMainLooper;
-    private final int mTargetSdkLevel;
-
+    final int mTargetSdkLevel;
+    private final Context mContext;
+    
+    // ADDED BY JH
+    private static IRemoteService mRemoteService;
+    private static SensorEventListener mRemoteSensorListener;
+    
     /** {@hide} */
     public SystemSensorManager(Context context, Looper mainLooper) {
-        mMainLooper = mainLooper;
+    	mMainLooper = mainLooper;
+        mContext = context;
         mTargetSdkLevel = context.getApplicationInfo().targetSdkVersion;
+        mRemoteService = IRemoteService.Stub.asInterface(ServiceManager
+				.getService(Context.REMOTE_SERVICE));
+        
         synchronized(sSensorModuleLock) {
             if (!sSensorModuleInitialized) {
                 sSensorModuleInitialized = true;
@@ -76,12 +88,34 @@
                         //        ", handle=" + sensor.getHandle());
                         fullList.add(sensor);
                         sHandleToSensor.append(sensor.getHandle(), sensor);
+                        
+                        /*try
+						{
+							mRemoteService.addSensorHandle(sensor.getType(), sensor.getHandle());
+						} 
+                        catch (RemoteException e)
+						{
+							// TODO Auto-generated catch block
+							e.printStackTrace();
+						}*/
+                        
+                        Log.d(TAG, "init- type: " + sensor.getType() + "handle: " + sensor.getHandle());
                     }
                 } while (i>0);
+                
+                Sensor sensor = new Sensor("RemoteSensor", Sensor.TYPE_REMOTE_SENSOR, Sensor.TYPE_REMOTE_SENSOR);
+                fullList.add(sensor);
+                sHandleToSensor.append(sensor.getHandle(), sensor);
+                
+                Log.d(TAG, "init- type: " + sensor.getType() + "handle: " + sensor.getHandle());
             }
         }
     }
 
+    /*SensorEventListener getRemoteListener()
+    {
+    	return mRemoteSensorListener;
+    }*/
 
     /** @hide */
     @Override
@@ -94,41 +128,125 @@
     @Override
     protected boolean registerListenerImpl(SensorEventListener listener, Sensor sensor,
             int delayUs, Handler handler, int maxBatchReportLatencyUs, int reservedFlags) {
-        if (listener == null || sensor == null) {
+    	if (listener == null || sensor == null) {
             Log.e(TAG, "sensor or listener is null");
             return false;
         }
-        // Trigger Sensors should use the requestTriggerSensor call.
+    	
+    	// Trigger Sensors should use the requestTriggerSensor call.
         if (Sensor.getReportingMode(sensor) == Sensor.REPORTING_MODE_ONE_SHOT) {
             Log.e(TAG, "Trigger Sensors should use the requestTriggerSensor.");
             return false;
         }
+        
         if (maxBatchReportLatencyUs < 0 || delayUs < 0) {
             Log.e(TAG, "maxBatchReportLatencyUs and delayUs should be non-negative");
             return false;
         }
-
+        
         // Invariants to preserve:
         // - one Looper per SensorEventListener
         // - one Looper per SensorEventQueue
         // We map SensorEventListener to a SensorEventQueue, which holds the looper
         synchronized (mSensorListeners) {
             SensorEventQueue queue = mSensorListeners.get(listener);
-            if (queue == null) {
+            
+            Log.d(TAG, mSensorListeners.toString());
+            
+            //if((queue == null) && (sensor.getType() == Sensor.TYPE_REMOTE_SENSOR))
+            	
+            /*if(sensor.getType() == Sensor.TYPE_REMOTE_SENSOR)
+            {
+            	mRemoteSensorListener = listener;
+            	return true;
+            }*/
+            
+            try
+			{
+            	if(mRemoteService == null)
+            	{
+            		Log.d(TAG, "type: " + sensor.getType() + " handle: " + sensor.getHandle());
+            		return false;
+            	}
+				mRemoteService.addSensorHandle(sensor.getType(), sensor.getHandle());
+				Log.d(TAG, "Hello: " + sensor.getType());
+				//RemoteSensorListener = listener;
+				
+				/*Looper looper = (handler != null) ? handler.getLooper() : mMainLooper;
+                queue = new SensorEventQueue(listener, looper, this);
+                
+                if (!queue.addSensor(sensor, delayUs, maxBatchReportLatencyUs, reservedFlags)) {
+	                queue.dispose();
+	                return false;
+	            }*/
+            }
+			catch (RemoteException e)
+			{
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+            
+            if (queue == null) 
+            {
                 Looper looper = (handler != null) ? handler.getLooper() : mMainLooper;
                 queue = new SensorEventQueue(listener, looper, this);
+                
                 if (!queue.addSensor(sensor, delayUs, maxBatchReportLatencyUs, reservedFlags)) {
-                    queue.dispose();
-                    return false;
-                }
-                mSensorListeners.put(listener, queue);
+	                queue.dispose();
+	                return false;
+	            }
+                
+                /*Log.d(TAG, "6: " + sensor.getType() + ", " + sensor.getHandle());
+                
+                // add handle in RemoteRequestHandler - ADDED BY JH
+                try
+    			{
+                	if(mRemoteService == null)
+                		Log.d(TAG, "type: " + sensor.getType() + " handle: " + sensor.getHandle());
+    				mRemoteService.addSensorHandle(sensor.getType(), sensor.getHandle());
+    				
+    				if(sensor.getType() == Sensor.TYPE_REMOTE_SENSOR)
+    				{
+    					Log.d(TAG, "7: " + sensor.getType() + ", " + sensor.getHandle());
+    					mRemoteService.setRemoteSensorOn(true);
+    					RemoteSensorListener = listener;
+    				}
+    			}
+    			catch (RemoteException e)
+    			{
+    				// TODO Auto-generated catch block
+    				e.printStackTrace();
+    			}*/
+                
                 return true;
-            } else {
+            } 
+            else 
+            {
+            	// add handle in RemoteRequestHandler
+                /*try
+    			{
+                	if(mRemoteService == null)
+                		Log.d(TAG, "type: " + sensor.getType() + " handle: " + sensor.getHandle());
+    				mRemoteService.addSensorHandle(sensor.getType(), sensor.getHandle());
+    				
+    				if(sensor.getType() == Sensor.TYPE_REMOTE_SENSOR)
+    				{
+    					Log.d(TAG, "8: " + sensor.getType() + ", " + sensor.getHandle());
+    					mRemoteService.setRemoteSensorOn(true);
+    					RemoteSensorListener = listener;
+    				}
+    			}
+    			catch (RemoteException e)
+    			{
+    				// TODO Auto-generated catch block
+    				e.printStackTrace();
+    			}*/
+                
                 return queue.addSensor(sensor, delayUs, maxBatchReportLatencyUs, reservedFlags);
             }
         }
     }
-
+    
     /** @hide */
     @Override
     protected void unregisterListenerImpl(SensorEventListener listener, Sensor sensor) {
@@ -136,8 +254,16 @@
         if (sensor != null && Sensor.getReportingMode(sensor) == Sensor.REPORTING_MODE_ONE_SHOT) {
             return;
         }
+        
+        
 
         synchronized (mSensorListeners) {
+        	if(sensor != null && sensor.getType() == Sensor.TYPE_REMOTE_SENSOR)
+            {
+            		mRemoteSensorListener = null;
+                	return;
+            }
+        	
             SensorEventQueue queue = mSensorListeners.get(listener);
             if (queue != null) {
                 boolean result;
@@ -150,6 +276,25 @@
                     mSensorListeners.remove(listener);
                     queue.dispose();
                 }
+                
+                // ADDED BY JH
+                try
+    			{
+                	if(mRemoteService == null)
+                		Log.d(TAG, "type: " + sensor.getType() + " handle: " + sensor.getHandle());
+    				mRemoteService.removeSensorHandle(sensor.getType());
+    				
+    				/*if(sensor.getType() == Sensor.TYPE_REMOTE_SENSOR)
+    				{
+    					//mRemoteService.setRemoteSensorOn(false);
+    					RemoteSensorListener = null;
+    				}*/
+    			}
+    			catch (RemoteException e)
+    			{
+    				// TODO Auto-generated catch block
+    				e.printStackTrace();
+    			}
             }
         }
     }
@@ -224,6 +369,11 @@
     private static abstract class BaseEventQueue {
         private native int nativeInitBaseEventQueue(BaseEventQueue eventQ, MessageQueue msgQ,
                 float[] scratch);
+        
+        // ADDED BY JH
+        //private native int nativeInitRemoteBaseEventQueue(BaseEventQueue eventQ, MessageQueue msgQ,
+        //        float[] scratch);
+        
         private static native int nativeEnableSensor(int eventQ, int handle, int rateUs,
                 int maxBatchReportLatencyUs, int reservedFlags);
         private static native int nativeDisableSensor(int eventQ, int handle);
@@ -242,6 +392,12 @@
             mCloseGuard.open("dispose");
             mManager = manager;
         }
+        
+        /*BaseEventQueue(Looper looper, SystemSensorManager manager, boolean isRemote) {
+            nSensorEventQueue = nativeInitRemoteBaseEventQueue(this, looper.getQueue(), mScratch);
+            mCloseGuard.open("dispose");
+            mManager = manager;
+        }*/
 
         public void dispose() {
             dispose(false);
@@ -256,10 +412,17 @@
             // Get ready to receive events before calling enable.
             mActiveSensors.put(handle, true);
             addSensorEvent(sensor);
+            Log.d(TAG, "addSensor: " + sensor.getName());
+            
+            // ADDED BY JH
+            /*if(sensor.getType() == Sensor.TYPE_REMOTE_SENSOR)
+            	return true;*/
             if (enableSensor(sensor, delayUs, maxBatchReportLatencyUs, reservedFlags) != 0) {
                 // Try continuous mode if batching fails.
+            	Log.d(TAG, "addSensor - enableSensor");
                 if (maxBatchReportLatencyUs == 0 ||
                     maxBatchReportLatencyUs > 0 && enableSensor(sensor, delayUs, 0, 0) != 0) {
+                	Log.d(TAG, "addSensor - enableSensor2: " + maxBatchReportLatencyUs);
                   removeSensor(sensor, false);
                   return false;
                 }
@@ -290,6 +453,18 @@
                 if (disable) disableSensor(sensor);
                 mActiveSensors.put(sensor.getHandle(), false);
                 removeSensorEvent(sensor);
+                
+                // remove handle in RemoteRequestHandler
+                try
+    			{
+    				mRemoteService.removeSensorHandle(sensor.getType());
+    			}
+    			catch (RemoteException e)
+    			{
+    				// TODO Auto-generated catch block
+    				e.printStackTrace();
+    			}
+                
                 return true;
             }
             return false;
@@ -331,6 +506,7 @@
                 Sensor sensor, int rateUs, int maxBatchReportLatencyUs, int reservedFlags) {
             if (nSensorEventQueue == 0) throw new NullPointerException();
             if (sensor == null) throw new NullPointerException();
+            
             return nativeEnableSensor(nSensorEventQueue, sensor.getHandle(), rateUs,
                     maxBatchReportLatencyUs, reservedFlags);
         }
@@ -338,28 +514,30 @@
         private int disableSensor(Sensor sensor) {
             if (nSensorEventQueue == 0) throw new NullPointerException();
             if (sensor == null) throw new NullPointerException();
+            
             return nativeDisableSensor(nSensorEventQueue, sensor.getHandle());
         }
         protected abstract void dispatchSensorEvent(int handle, float[] values, int accuracy,
-                long timestamp);
+                long timestamp, int sourceDevice);
         protected abstract void dispatchFlushCompleteEvent(int handle);
 
         protected abstract void addSensorEvent(Sensor sensor);
         protected abstract void removeSensorEvent(Sensor sensor);
     }
 
-    static final class SensorEventQueue extends BaseEventQueue {
+    public static final class SensorEventQueue extends BaseEventQueue {
         private final SensorEventListener mListener;
         private final SparseArray<SensorEvent> mSensorsEvents = new SparseArray<SensorEvent>();
-
+        
         public SensorEventQueue(SensorEventListener listener, Looper looper,
-                SystemSensorManager manager) {
-            super(looper, manager);
+                SystemSensorManager systemSensorManager) {
+            super(looper, systemSensorManager);
             mListener = listener;
         }
-
+        
         @Override
         public void addSensorEvent(Sensor sensor) {
+        	Log.d(TAG, "addSensorEvent(Sensor): " + sensor.getName());
             SensorEvent t = new SensorEvent(Sensor.getMaxLengthValuesArray(sensor,
                     mManager.mTargetSdkLevel));
             synchronized (mSensorsEvents) {
@@ -378,9 +556,10 @@
         @SuppressWarnings("unused")
         @Override
         protected void dispatchSensorEvent(int handle, float[] values, int inAccuracy,
-                long timestamp) {
-            final Sensor sensor = sHandleToSensor.get(handle);
-            SensorEvent t = null;
+                long timestamp, int sourceDevice) {
+        	
+        	final Sensor sensor = sHandleToSensor.get(handle);
+        	SensorEvent t = null;
             synchronized (mSensorsEvents) {
                 t = mSensorsEvents.get(handle);
             }
@@ -390,34 +569,63 @@
                 // the queue waiting to be delivered. Ignore.
                 return;
             }
+            
             // Copy from the values array.
             System.arraycopy(values, 0, t.values, 0, t.values.length);
             t.timestamp = timestamp;
             t.accuracy = inAccuracy;
             t.sensor = sensor;
+            t.sourceDevice = sourceDevice;
+            
+            // ADDED FOR COLLABOROID
+            try
+			{
+            	if(sensor.getType() == Sensor.TYPE_ORIENTATION || sensor.getType() == Sensor.TYPE_PROXIMITY)
+            	{
+            		Log.d("SensorStart", "sensor start!  ");
+            		mRemoteService.sendSensorEvent(t.sensor.getType(), handle, values, inAccuracy, timestamp);
+            	}
+            }
+			catch (RemoteException e)
+			{
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+            
             switch (t.sensor.getType()) {
-                // Only report accuracy for sensors that support it.
-                case Sensor.TYPE_MAGNETIC_FIELD:
-                case Sensor.TYPE_ORIENTATION:
-                    // call onAccuracyChanged() only if the value changes
-                    final int accuracy = mSensorAccuracies.get(handle);
-                    if ((t.accuracy >= 0) && (accuracy != t.accuracy)) {
-                        mSensorAccuracies.put(handle, t.accuracy);
-                        mListener.onAccuracyChanged(t.sensor, t.accuracy);
-                    }
-                    break;
-                default:
-                    // For other sensors, just report the accuracy once
-                    if (mFirstEvent.get(handle) == false) {
-                        mFirstEvent.put(handle, true);
-                        mListener.onAccuracyChanged(
-                                t.sensor, SENSOR_STATUS_ACCURACY_HIGH);
-                    }
-                    break;
+            // Only report accuracy for sensors that support it.
+            case Sensor.TYPE_MAGNETIC_FIELD:
+            case Sensor.TYPE_ORIENTATION:
+                // call onAccuracyChanged() only if the value changes
+                final int accuracy = mSensorAccuracies.get(handle);
+                if ((t.accuracy >= 0) && (accuracy != t.accuracy)) {
+                    mSensorAccuracies.put(handle, t.accuracy);
+                    mListener.onAccuracyChanged(t.sensor, t.accuracy);
+                }
+                break;
+            default:
+                // For other sensors, just report the accuracy once
+                if (mFirstEvent.get(handle) == false) {
+                    mFirstEvent.put(handle, true);
+                    mListener.onAccuracyChanged(
+                            t.sensor, SENSOR_STATUS_ACCURACY_HIGH);
+                }
+                break;
+        	}
+            // ADDED BY JH
+            /*if(t.sourceDevice != 0)
+            {
+            	//t.sensor = sHandleToSensor.get(Sensor.TYPE_REMOTE_SENSOR);
+            	Log.d(TAG, "type::::: "+t.sensor.getType());
+            	t.sensor = new Sensor("RemoteSensor", handle, Sensor.TYPE_REMOTE_SENSOR);
+            	//SystemSensorManager.mRemoteSensorListener.onSensorChanged(t);
+                //RemoteSensorListener.onSensorChanged(t);
+            	mListener.onSensorChanged(t);
             }
+            else      */      
             mListener.onSensorChanged(t);
         }
-
+        
         @SuppressWarnings("unused")
         protected void dispatchFlushCompleteEvent(int handle) {
             if (mListener instanceof SensorEventListener2) {
@@ -433,13 +641,14 @@
         private final SparseArray<TriggerEvent> mTriggerEvents = new SparseArray<TriggerEvent>();
 
         public TriggerEventQueue(TriggerEventListener listener, Looper looper,
-                SystemSensorManager manager) {
-            super(looper, manager);
+        		SystemSensorManager systemSensorManager) {
+            super(looper, systemSensorManager);
             mListener = listener;
         }
 
         @Override
         public void addSensorEvent(Sensor sensor) {
+        	Log.d(TAG, "addSensorEvent(Trigger): " + sensor.getName());
             TriggerEvent t = new TriggerEvent(Sensor.getMaxLengthValuesArray(sensor,
                     mManager.mTargetSdkLevel));
             synchronized (mTriggerEvents) {
@@ -458,8 +667,9 @@
         @SuppressWarnings("unused")
         @Override
         protected void dispatchSensorEvent(int handle, float[] values, int accuracy,
-                long timestamp) {
+                long timestamp, int sourceDevice) {
             final Sensor sensor = sHandleToSensor.get(handle);
+            Log.d(TAG, "dispatchSensorEvent(Trigger): " + sensor.getName());
             TriggerEvent t = null;
             synchronized (mTriggerEvents) {
                 t = mTriggerEvents.get(handle);
@@ -485,4 +695,4 @@
         protected void dispatchFlushCompleteEvent(int handle) {
         }
     }
-}
+}
\ No newline at end of file
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/os/SystemVibrator.java AndroidSource/frameworks/base/core/java/android/os/SystemVibrator.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/os/SystemVibrator.java	2016-01-29 15:12:27.431488000 +0900
+++ AndroidSource/frameworks/base/core/java/android/os/SystemVibrator.java	2016-09-26 17:12:48.515829267 +0900
@@ -18,8 +18,12 @@
 
 import android.app.ActivityThread;
 import android.content.Context;
+import android.service.remote.IRemoteService;
+import android.service.remote.RemoteRequest;
 import android.util.Log;
 
+import java.util.ArrayList;
+
 /**
  * Vibrator implementation that controls the main system vibrator.
  *
@@ -32,16 +36,24 @@
     private final IVibratorService mService;
     private final Binder mToken = new Binder();
 
+    private IRemoteService mRemoteService; 
+    
+    
     public SystemVibrator() {
         mPackageName = ActivityThread.currentPackageName();
         mService = IVibratorService.Stub.asInterface(
                 ServiceManager.getService("vibrator"));
+        mRemoteService = IRemoteService.Stub.asInterface(ServiceManager
+                .getService(Context.REMOTE_SERVICE));
+        
     }
 
     public SystemVibrator(Context context) {
         mPackageName = context.getOpPackageName();
         mService = IVibratorService.Stub.asInterface(
                 ServiceManager.getService("vibrator"));
+        mRemoteService = IRemoteService.Stub.asInterface(ServiceManager
+                .getService(Context.REMOTE_SERVICE));
     }
 
     @Override
@@ -81,6 +93,20 @@
         } catch (RemoteException e) {
             Log.w(TAG, "Failed to vibrate.", e);
         }
+        
+        
+        
+        ArrayList<Object> para = new ArrayList<Object>();
+        para.add(milliseconds);
+        
+        RemoteRequest request = new RemoteRequest("systemCall", "vibrate", para);
+        try {
+            mRemoteService.sendAllrequestVib(request);
+        } catch (RemoteException e) {
+            // TODO Auto-generated catch block
+//            e.printStackTrace();
+        }
+        
     }
 
     /**
@@ -104,6 +130,9 @@
         } else {
             throw new ArrayIndexOutOfBoundsException();
         }
+        
+
+        
     }
 
     @Override
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/provider/Settings.java AndroidSource/frameworks/base/core/java/android/provider/Settings.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/provider/Settings.java	2016-01-29 15:12:27.439488000 +0900
+++ AndroidSource/frameworks/base/core/java/android/provider/Settings.java	2016-06-20 16:56:35.000000000 +0900
@@ -1101,6 +1101,7 @@
             MOVED_TO_GLOBAL.add(Settings.Global.SMS_SHORT_CODES_UPDATE_METADATA_URL);
             MOVED_TO_GLOBAL.add(Settings.Global.CERT_PIN_UPDATE_CONTENT_URL);
             MOVED_TO_GLOBAL.add(Settings.Global.CERT_PIN_UPDATE_METADATA_URL);
+
         }
 
         /** @hide */
@@ -2860,6 +2861,15 @@
             MOVED_TO_GLOBAL.add(Settings.Global.SET_GLOBAL_HTTP_PROXY);
             MOVED_TO_GLOBAL.add(Settings.Global.DEFAULT_DNS_SERVER);
             MOVED_TO_GLOBAL.add(Settings.Global.PREFERRED_NETWORK_MODE);
+            
+            // ADDED FOR COLLABOROID
+            MOVED_TO_GLOBAL.add(Settings.Global.REMOTE_REQUEST_SERVER_ON);
+            MOVED_TO_GLOBAL.add(Settings.Global.REMOTE_REQUEST_CLIENT_ON);
+            MOVED_TO_GLOBAL.add(Settings.Global.COLLABOROID_ON);
+            MOVED_TO_GLOBAL.add(Settings.Global.SYSTEM_SERVICE_ON);
+            MOVED_TO_GLOBAL.add(Settings.Global.TASK_EXECUTOR_ON);
+            MOVED_TO_GLOBAL.add(Settings.Global.COLLABOROID_DEVICE_NAME);
+            // ADDED FOR COLLABOROID
         }
 
         /** @hide */
@@ -5935,6 +5945,18 @@
          */
         public static final String LOW_BATTERY_SOUND_TIMEOUT = "low_battery_sound_timeout";
 
+        // ADDED BY DCSLAB
+        public static final String REMOTE_REQUEST_SERVER_ON = "remote_request_server_on";
+        public static final String REMOTE_REQUEST_CLIENT_ON = "remote_request_client_on";
+
+        public static final String COLLABOROID_ON = "collaboroid_on";
+        
+        public static final String SYSTEM_SERVICE_ON = "system_service_on";
+        public static final String TASK_EXECUTOR_ON = "task_executor_on";
+        
+        public static final String COLLABOROID_DEVICE_NAME = "collaboroid_device_name";
+        
+
         /**
          * Settings to backup. This is here so that it's in the same place as the settings
          * keys and easy to update.
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/collaboroid/IGeneralMessageListener.aidl AndroidSource/frameworks/base/core/java/android/service/collaboroid/IGeneralMessageListener.aidl
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/collaboroid/IGeneralMessageListener.aidl	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/collaboroid/IGeneralMessageListener.aidl	2016-03-04 14:09:26.000000000 +0900
@@ -0,0 +1,6 @@
+package android.service.collaboroid;
+
+oneway interface IGeneralMessageListener
+{
+	void onMessageReceived(String message);
+}
\ No newline at end of file
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/devicemanager/Device.aidl AndroidSource/frameworks/base/core/java/android/service/devicemanager/Device.aidl
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/devicemanager/Device.aidl	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/devicemanager/Device.aidl	2016-01-11 19:24:34.000000000 +0900
@@ -0,0 +1,3 @@
+package android.service.devicemanager;
+
+parcelable Device;
\ No newline at end of file
